



#ifndef GRAPH_H

#define GRAPH_H
#include <map>
#include <vector>
#include <list>
#include <string>


typedef std::vector< std::map< int, int > > net;


class Graph
{
    public :
        const bool has_node(int node, int time) const;
        int degree(int node, int time);
        const std::list< int > &nodes() const;
        void read_cin();
        void load(std::string fname);
        void create_from(std::map<int, int> & n2c, const Graph &origin);
        const int maxtime() const;
        const int mintime() const;
        const int duration(int) const;
        const int total_weight(const int time) const;
        const std::map<int, int > &  get_neighbors(int node, int time) const;
        void print(int time);
        void set_maxtime(int);
        void set_mintime(int);

        std::vector<int> m_total_weight;
        int m_maxtime;
        int m_mintime;
        std::vector< std::map<int, int> > m_gdegree;
        std::vector< net > m_neighbors;
        std::list< int > m_allnodes;
        std::vector<double> m_duration;

};




#endif

