


#include<map>
#include <vector>

#include "graph.h"


class LouvainLevel
{

    public :
        void init(Graph * g);
        void init_alone();
        int n2c(int);
        void one_level();
        bool debug;
        // community to which each node belongs

        std::map<int, int> m_n2c;
    private :


        void removes(int& node, int& com, std::vector<int>& weights);
        void inserts(int node, int com, std::vector<int>&  weights);
        void remove(int node, int comm, int dnodecomm, int time);
        void insert(int, int, int, int);

        int best_increase(int node, int com_node, std::map< int, std::vector<int> >);

        std::map<int, int> neighcom(int node, int time);
        std::map< int, std::vector<int> > neighcoms(int node);

        void reset();



        Graph * m_g;

        

        // used to compute the modularity participation of each community
        std::vector< std::map<int, int> > gdegree;
        std::vector< std::map<int , int> > degree;
};


